
#ifndef CHATLINE_HPP
#define CHATLINE_HPP

#include <string>
#include <map>


using std::string;
using std::map;


/**
Chat content, parser and formatter.
A chat is sent in the format

command=login&username=petar&password=lozinka
**/
class ChatLine
{
private:

	map<string, string> _params;
	
public:

	static const string PARAM_SEP;
	
	static const string NAME_VALUE_SEP;

	ChatLine();

	string command();

	void command(string cmd);

	string username();

	void username(string user);
	
	string password();

	void password(string pass);
	
	void to(string t);

	string to();

	void from(string f);

	string from();

	void chatLine(string line);
	
	string chatLine();

	bool empty();
	
	string toString();

	bool parse(string request);
	
	string format();
};

#endif // CHATLINE_HPP
