
#ifndef DISPATCHER_HPP
#define DISPATCHER_HPP

#include <deque>
#include <Poco/Runnable.h>
#include <Poco/Mutex.h>
#include <Poco/ThreadPool.h>
#include <Poco/Condition.h>
#include "Message.hpp"


using std::deque;
using Poco::Runnable;
using Poco::FastMutex;
using Poco::ThreadPool;
using Poco::Condition;


/**
Determines clients ready to handle.
**/
class Dispatcher : public Runnable
{
public:

	static const short CHUNK_SIZE = 50;
	
	Dispatcher();

	void run();
	
	void enqueue(Message* message);
	
private:

	Condition _condQueue;

	FastMutex _mutexQueue;

	deque<Message*> _queue;
	
	void dequeue(map<StreamSocket, Message*>& messages);
};


#endif // DISPATCHER_HPP
