
#include <cassert>
#include "Message.hpp"


Message* Message::create(StreamSocket* socket)
{
	Message* msg = new Message;
	msg->session(new Session(socket));
	msg->chatLine(NULL);
	return msg;
}


Message* Message::create(StreamSocket* socket, ChatLine* line)
{
	Message* msg = new Message;
	msg->session(new Session(socket));
	msg->chatLine(line);
	return msg;
}


void Message::destroy(Message* msg)
{
	if (msg != NULL)
		delete msg;
}


Message::Message() : _session(NULL), _chatLine(NULL)
{
}


Message::~Message()
{
	if (_session != NULL)
		delete _session;
	if (_chatLine != NULL)
		delete _chatLine;
}


Session* Message::session()
{
	return _session;
}


void Message::session(Session* s)
{
	if (_session != NULL)
		delete _session;
	_session = s;
}


ChatLine* Message::chatLine()
{
	return _chatLine;
}


void Message::chatLine(ChatLine* line)
{
	if (_chatLine != NULL)
		delete _chatLine;
	_chatLine = line;
}
