
#ifndef MESSAGE_HPP
#define MESSAGE_HPP

#include "Session.hpp"
#include "ChatLine.hpp"


/**
Stores chat content and session status.
Only one message/session exist for a particular socket.
**/
class Message
{
public:

	static Message* create(StreamSocket* socket);
	
	static Message* create(StreamSocket* socket, ChatLine* line);
	
	static void destroy(Message* t);
	
	Message();
	
	~Message();
	
	Session* session();
	
	void session(Session* s);
	
	ChatLine* chatLine();
	
	void chatLine(ChatLine* line);

private:

	Session* _session;
	
	ChatLine* _chatLine;
};

#endif // MESSAGE_HPP
