
#include <Poco/Net/Socket.h>
#include <Poco/Net/StreamSocket.h>
#include <Poco/Logger.h>
#include <Poco/Format.h>
#include <Poco/Timespan.h>
#include "Server.hpp"
#include "ChatLine.hpp"


using Poco::Net::Socket;
using Poco::Net::StreamSocket;
using Poco::Logger;
using Poco::Timespan;


Server::Server(Dispatcher* dispatcher) : _serverSocket(PORT), _dispatcher(dispatcher)
{
	_serverSocket.listen();
	Logger& log = Logger::get("server");
	log.debug("Server::Server(): listening");
}


void Server::run()
{
	Logger& log = Logger::get("server");
	const Timespan TIMEOUT(0, 100000);

	while (true)
	{
		if (_serverSocket.poll(TIMEOUT, Socket::SELECT_READ))
		{
			StreamSocket client = _serverSocket.acceptConnection();
			Message* msg = Message::create(new StreamSocket(client));
			msg->session()->status(Session::NEW);
			log.information("Server::run(): session " + Poco::format("%ld", msg->session()->id()) + " created");
			_dispatcher->enqueue(msg);
		}
	}
}
