
#ifndef SERVER_HPP
#define SERVER_HPP

#include <map>
#include <deque>
#include <vector>
#include <Poco/Net/Socket.h>
#include <Poco/Net/ServerSocket.h>
#include <Poco/Runnable.h>
#include <Poco/Mutex.h>
#include <Poco/ThreadPool.h>
#include "Dispatcher.hpp"


using Poco::Net::Socket;
using Poco::Net::ServerSocket;
using Poco::Runnable;
using Poco::FastMutex;
using Poco::ThreadPool;


/**
Accepts new clients.
**/
class Server : public Runnable
{
public:

	Server(Dispatcher* dispatcher);

	void run();

private:

	static const short PORT = 7000;

	static const short BUF_SIZE = 128;

	ServerSocket _serverSocket;
	
	Dispatcher* _dispatcher;
};

#endif // SERVER_HPP
